/* @(#)AGrocery.java 1.0  22 April 2003 */

/* Abstract class to represent variants of grocery items */

abstract public class AGrocery {

    
    /*--------------------------------------------------------
     Member Data
     -------------------------------------------------------*/

	/* the size of the grocery item in ounces */
	public double size;
	
	/* the price of the item in cents */
	public double price;
	
	/* the brand of this item */
	public String brand;
	
    /*--------------------------------------------------------
     Methods
     -------------------------------------------------------*/
	/* compute the unit price of item, 
	   given the size and price */
	public double unitPrice(){
		return size/price;
	}
	
	/* determine whether the unit price of this item 
	   is cheaper than given price */
	public boolean isCheaperThan(double somePrice){
		return (this.unitPrice() < somePrice);
	}
	
	/* determine whether the unit price of this item 
	   is cheaper than the unit price of the given item */
	public boolean betterPriceThan(AGrocery someItem){
		return this.unitPrice() < someItem.unitPrice();
	}
	
    /*--------------------------------------------------------
     Template
     ---------------------------------------------------------
	
	 ...this.size...
	 ...this.price...
	 ...this.unitPrice()...
	 ...this.isCheaperThan(double somePrice)...
	 ...this.betterPriceThan(AGrocery someItem)...
	 
	 ...someItem.size...
	 ...someItem.price...
	 ...someItem.unitPrice()...
	 ...someItem.isCheaperThan(double somePrice)...
	 ...someItem.betterPriceThan(AGrocery someItem)...
	 
     -------------------------------------------------------*/

}