/* @(#)TestSuite.java 1.0  22 April 2003 */

import edu.neu.ccs.*;
import edu.neu.ccs.gui.*;
import edu.neu.ccs.codec.*;
import edu.neu.ccs.console.*;
import edu.neu.ccs.filter.*;
import edu.neu.ccs.jpf.*;
import edu.neu.ccs.parser.*;
import edu.neu.ccs.pedagogy.*;
import edu.neu.ccs.util.*;

import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.awt.font.*;
import java.util.*;
import java.text.*;
import java.math.*;
import javax.swing.*;
import java.lang.reflect.*;
import java.net.URL;

public class TestSuite extends JPFalt 
{
    public static void main(String[] args) { new TestSuite(); }
    
    /*--------------------------------------------------------
     Object that can be used in all examples
     -------------------------------------------------------*/
	
	/* Coffee objects */
	Coffee star = new Coffee(16.0, 3.20, 
	                         "Starbucks", "regular");
	Coffee maxh = new Coffee(10.0, 2.40, 
	                         "Maxwell House", "instant");
	Coffee folg = new Coffee(12.0, 3.60, 
	                         "Folgers", "decaf");
	                         
	/* Juice objects */
	Juice trop = new Juice(64.0, 3.20, 
	                       "Tropicana", "fresh");	                         
	Juice minm = new Juice(64.0, 2.40, 
	                       "Minute Maid", "frozen");	                         
	Juice flor = new Juice(32.0, 2.40, 
	                       "Florida", "fresh");
	                         
	/* Ice Cream objects */
	IceCream brye = new IceCream(32.0, 3.20, 
	                    "Bryers", "chocolate", "ice cream");	                         
	IceCream bjer = new IceCream(16.0, 3.20, 
	                    "Ben&Jerry", "fudge", "light");
	IceCream hagd = new IceCream(64.0, 3.20, 
	                    "HaagenDazs", "raspberry", "sorbet");	                         

    /*--------------------------------------------------------
     Place your methods here
     -------------------------------------------------------*/

	/* Tests for Coffee class */
	public void testCoffee(){
		println(star);
		println(maxh);
		println(folg);
		
		expected(5.00);
		actual(star.unitPrice());
		expected(4.167);
		actual(maxh.unitPrice());
		expected(3.33);
		actual(folg.unitPrice());
		
		expected(false);
		actual(star.isCheaperThan(4.0));
		expected(true);
		actual(folg.isCheaperThan(4.0));

		expected(false);
		actual(star.betterPriceThan(folg));
		expected(true);
		actual(folg.betterPriceThan(maxh));

		expected(false);
		actual(star.isInstant());
		expected(true);
		actual(maxh.isInstant());
	}

	/* Tests for Juice class */
	public void testJuice(){
		println(trop);
		println(minm);
		println(flor);
		expected(20.0);
		actual(trop.unitPrice());
		expected(26.67);
		actual(minm.unitPrice());
		expected(0.20);
		actual(flor.unitPrice());

		expected(false);
		actual(minm.isCheaperThan(20.0));
		expected(true);
		actual(flor.isCheaperThan(20.0));

		expected(false);
		actual(trop.betterPriceThan(flor));
		expected(true);
		actual(trop.betterPriceThan(minm));

		expected(false);
		actual(minm.isFresh());
		expected(true);
		actual(trop.isFresh());
	}

	/* Tests for IceCream class */
	public void testIceCream(){
		println(brye);
		println(bjer);
		println(hagd);	
		expected(10.0);
		actual(brye.unitPrice());
		expected(5.0);
		actual(bjer.unitPrice());
		expected(20.0);
		actual(hagd.unitPrice());

		expected(false);
		actual(brye.isCheaperThan(10.0));
		expected(true);
		actual(bjer.isCheaperThan(10.0));

		expected(false);
		actual(brye.betterPriceThan(bjer));
		expected(true);
		actual(brye.betterPriceThan(hagd));

		expected(false);
		actual(bjer.isSorbet());
		expected(true);
		actual(hagd.isSorbet());
	}

}